/* ====================*/

/************** чтение данных UART с окончанием по таймауту */

uint8 ReadRxData (char* Rx_Buffer,uint8 timeout)			// буфер и таймаут в милисекундах
{
uint8 RxCount=0;
while (UART_GetRxBufferSize())								// ПОКА В Rx буфере UART есть байты:
	{
		Rx_Buffer[RxCount]=UART_GetChar();					// вычитываем принятые байты  в RxBuffer 
		RxCount++;											// переходим к следующей ячейке буфера
		if (!UART_GetRxBufferSize())  CyDelay(timeout);		// если данные закончились - ждем указаное время
		if(RxCount>127)										// если есть помехи или скорость не та буфер будет забит всякой хренью
			{
			memset (Rx_Buffer,'\0',127);					//  - почистим его
			return 1;										// и выходим с ошибкой переполнения буфера(1)
			}	
	}
	Rx_Buffer[RxCount]=0;									//забиваем нолик в конец буфера (признак конца строки)
return 0;
}//______________________________________________________


/********************  поиск на разных скоростях  и настройка на заданную  ****************************************************/

uint8 Cogfig_Device (char* Etalon, uint16 tmSec)
{
extern char *AT_Command[];
extern int16    Divider[];
extern int8        MyBaud;

uint8 i=0;													// вернем как номер Baudrate[] порта
uint16 timeout=0;											// время ожидания ответа
char Ask_buffer[8]= {0};									// буфер хранения ответа от модуля




	LCD_Char_Position(1,0);
for( i=1;i<7;i++)											// начинаем поиск на разных скоростях
  {
	LCD_Char_PrintString("*");
 	UART_CLOCK_SetDivider(Divider[i]);						// настраиваем UART_CLOCK  делителем 
	UART_PutString("AT");									// отправляем запрос 
	timeout=0;												// начнем отсчет ожидания
	while (!UART_GetRxBufferSize()&(timeout<tmSec))			// ждем ответ течении  tmSec милисекунд
			{ timeout++ ;  CyDelay(1); }
	ReadRxData (Ask_buffer, 50);							// посмотрим,нет ли в буфере ответа от модуля
	
	if ( !strncmp(Ask_buffer,Etalon,sizeof(Etalon)) ) 		// сравним ответ и образец (OK) 
		{   
		UART_PutString(AT_Command[MyBaud]);					// модуль найден, устанавливаем нужную скорость
		CyDelay(tmSec);										// тупо подождем tmSec милисекунд
		ReadRxData (Ask_buffer, 50);
		if ( !strncmp(Ask_buffer,Etalon,2) ) return MyBaud;	// проверим установку  скорости и выходим если нет ошибки
		return 255;											// возвращаем код ошибки установки  скорости
		}
 	memset (Ask_buffer,'\0',8);								//  очистим буфер для следующего поиска
  }//______________________________________________________

return 0;	// Устройство не найдено

}



	//[] END OF FILE