/* --------------------------------------------------------------------------


***************************************************************************** */

#include <device.h>
#include "MyISRs.h"
#include "MyData_and_Fun.h"

uint8 flag_end =1;  	// флаг запроса ( 0-в обработке, команды не посылать)
uint8 DevPresent=0;		// флаг наличия устройства
char buffer[64];		// буфер для данных от UART  
uint16 pause = 600;	// максимальноевремя задержки ответа модуля  HC-04


/************** таблица настройки UART и HC-04  ********************/
int16    Divider[8]= {     0          ,    625   ,   312    ,   156    ,   104    ,     52   ,    26     ,    13     };	// коэффициенты деления для UART_CLOCK при master_clock = 48 МГц
char   *Baudrate[8]= {"NO device     ",  "9600"  , "19200"  ,  "38400" , "57600"  , "115200" , "230400"  , "460800"  };	// соответствующие скорости
char *AT_Command[8]= {"ERROR     "     ,"AT+BAUD4","AT+BAUD5","AT+BAUD6","AT+BAUD7","AT+BAUD8", "AT+BAUD9", "AT+BAUDA"};	// AT команды для HC-04    1200(1),2400(2),4800(3),9600(4),19200(5),38400(6), 57600(7),115200(8),230400(9),460800(A),921600(B), 1382400(C) 
int8 MyBaud = 2;    //     0               1          2           3         4          5           6           7           set baudrate = 230400
	


int main(void)
{

	ISR_UART_StartEx(ISR_UART);								// set my interrupts
    CYGlobalIntEnable;										// Enable all interrupts

	LCD_Char_Start();										// Enable LCD component 	
	LCD_Char_Position(0,0);
	LCD_Char_PrintString("Find HC-04: ");					 
															// Enable UART component 
	UART_Start();		
	UART_CLOCK_SetDivider(Divider[MyBaud]);  				// коэффициент деления для UART_CLOCK при master_clock = 48 МГц
	CyDelay(pause);											// подождем пока настроится UART и изменится делитель 
	//memset (buffer,'\0',64);								// очистим буфер 
	UART_PutString("AT");									// отправляем запрос 
	CyDelay(pause);											// ждем пока bluetooth модуль  отреагирует  на  команду
	ReadRxData (buffer, 50);								// послушаем ответ
	if ( !strncmp(buffer,"OK",2) ) 							// если получен ответ (OK)
		{
			LCD_Char_PrintString("OK  ");
			LCD_Char_Position(1,0);  
			LCD_Char_PrintString("Baud: ");		// отображаем обнаружение устройства
			LCD_Char_PrintString(Baudrate[MyBaud]);
			DevPresent=1; 									// поднимем  флаг наличия устройства
		}
	else
		{
			DevPresent = Cogfig_Device ("OK",pause);			// ждем ответ "OK" в течении pause мСек на каждой скорости и настраиваем на нужную
			LCD_Char_Position(1,0);
			if (DevPresent==255) LCD_Char_PrintString("Set baud error "); 
			if (DevPresent) LCD_Char_PrintString("baud set: "); 
			LCD_Char_PrintString(Baudrate[DevPresent]);		// выводим результат поиска модуля
			LCD_Char_PrintString("  ");
		}
//CyDmaChEnable(DMA_UART_Chan, 1);							// Поиск закончен, разрешаем работу DMA с UART
	
	 while(1)
	{
	// DevPresent - флаг результата поиска. 
	// Устройство обнаружено (или найдено и настроено) дальше можно писать программу работы с ним.

	CyDelay(250);	
	Rx_LED_Write(Rx_LED_Read()^DevPresent);  	// мигаем светодиодом если устройство найдено

	}		
}
/* [] END OF FILE */
